gi-gio-2.0.27: Gio bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gio.Interfaces.Action

Contents

- Exported types
- Methods
  - Overloaded methods
  - activate
  - changeState
  - getEnabled
  - getName
  - getParameterType
  - getState
  - getStateHint
  - getStateType
  - nameIsValid
  - parseDetailedName
  - printDetailedName
- Properties
  - enabled
  - name
  - parameterType
  - state
  - stateType

Description

`Action` represents a single named action.

The main interface to an action is that it can be activated with `actionActivate`. This results in the 'activate' signal being emitted. An activation has a `GVariant` parameter (which may be `Nothing`). The correct type for the parameter is determined by a static parameter type (which is given at construction time).

An action may optionally have a state, in which case the state may be set with `actionChangeState`. This call takes a `GVariant`. The correct type for the state is determined by a static state type (which is given at construction time).

The state may have a hint associated with it, specifying its valid range.

`Action` is merely the interface to the concept of an action, as described above. Various implementations of actions exist, including `SimpleAction`.

In all cases, the implementing class is responsible for storing the name of the action, the parameter type, the enabled state, the optional state type and the state and emitting the appropriate signals when these change. The implementor is responsible for filtering calls to `actionActivate` and `actionChangeState` for type safety and for the state being enabled.

Probably the only useful thing to do with a `Action` is to put it inside of a `SimpleActionGroup`.

Synopsis

- newtype Action = Action (ManagedPtr Action)
- class (GObject o, IsDescendantOf Action o) => IsAction o
- toAction :: (MonadIO m, IsAction o) => o -> m Action
- actionActivate :: (HasCallStack, MonadIO m, IsAction a) => a -> Maybe GVariant -> m ()
- actionChangeState :: (HasCallStack, MonadIO m, IsAction a) => a -> GVariant -> m ()
- actionGetEnabled :: (HasCallStack, MonadIO m, IsAction a) => a -> m Bool
- actionGetName :: (HasCallStack, MonadIO m, IsAction a) => a -> m Text
- actionGetParameterType :: (HasCallStack, MonadIO m, IsAction a) => a -> m (Maybe VariantType)
- actionGetState :: (HasCallStack, MonadIO m, IsAction a) => a -> m GVariant
- actionGetStateHint :: (HasCallStack, MonadIO m, IsAction a) => a -> m (Maybe GVariant)
- actionGetStateType :: (HasCallStack, MonadIO m, IsAction a) => a -> m (Maybe VariantType)
- actionNameIsValid :: (HasCallStack, MonadIO m) => Text -> m Bool
- actionParseDetailedName :: (HasCallStack, MonadIO m) => Text -> m (Text, GVariant)
- actionPrintDetailedName :: (HasCallStack, MonadIO m) => Text -> Maybe GVariant -> m Text
- getActionEnabled :: (MonadIO m, IsAction o) => o -> m Bool
- getActionName :: (MonadIO m, IsAction o) => o -> m Text
- getActionParameterType :: (MonadIO m, IsAction o) => o -> m (Maybe VariantType)
- getActionState :: (MonadIO m, IsAction o) => o -> m (Maybe GVariant)
- getActionStateType :: (MonadIO m, IsAction o) => o -> m (Maybe VariantType)

# Exported types

newtype Action Source #

Memory-managed wrapper type.

Constructors

Action (ManagedPtr Action) |

#### Instances

Instances details

Eq Action Source # |
Instance details Defined in GI.Gio.Interfaces.Action Methods (==) :: Action -> Action -> Bool # (/=) :: Action -> Action -> Bool #
GObject Action Source # |
Instance details Defined in GI.Gio.Interfaces.Action
TypedObject Action Source # |
Instance details Defined in GI.Gio.Interfaces.Action Methods glibType :: IO GType Source #
ManagedPtrNewtype Action Source # |
Instance details Defined in GI.Gio.Interfaces.Action Methods toManagedPtr :: Action -> ManagedPtr Action Source #
IsGValue Action Source # | Convert `Action` to and from `GValue` with `toGValue` and `fromGValue`.
Instance details Defined in GI.Gio.Interfaces.Action Methods toGValue :: Action -> IO GValue Source # fromGValue :: GValue -> IO Action Source #
HasParentTypes Action Source # |
Instance details Defined in GI.Gio.Interfaces.Action
type ParentTypes Action Source # |
Instance details Defined in GI.Gio.Interfaces.Action type ParentTypes Action = '[Object]

class (GObject o, IsDescendantOf Action o) => IsAction o Source #

Type class for types which can be safely cast to `Action`, for instance with `toAction`.

#### Instances

Instances details

(GObject o, IsDescendantOf Action o) => IsAction o Source # |
Instance details Defined in GI.Gio.Interfaces.Action

toAction :: (MonadIO m, IsAction o) => o -> m Action Source #

Cast to `Action`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

## Overloaded methods

## activate

actionActivate Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Action`
-> Maybe GVariant | `parameter`: the parameter to the activation
-> m () |

Activates the action.

`parameter` must be the correct type of parameter for the action (ie: the parameter type given at construction time). If the parameter type was `Nothing` then `parameter` must also be `Nothing`.

If the `parameter` GVariant is floating, it is consumed.

Since: 2.28

## changeState

actionChangeState Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Action`
-> GVariant | `value`: the new state
-> m () |

Request for the state of `action` to be changed to `value`.

The action must be stateful and `value` must be of the correct type. See `actionGetStateType`.

This call merely requests a change. The action may refuse to change its state or may change its state to something other than `value`. See `actionGetStateHint`.

If the `value` GVariant is floating, it is consumed.

Since: 2.30

## getEnabled

actionGetEnabled Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Action`
-> m Bool | Returns: whether the action is enabled

Checks if `action` is currently enabled.

An action must be enabled in order to be activated or in order to have its state changed from outside callers.

Since: 2.28

## getName

actionGetName Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Action`
-> m Text | Returns: the name of the action

Queries the name of `action`.

Since: 2.28

## getParameterType

actionGetParameterType Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Action`
-> m (Maybe VariantType) | Returns: the parameter type

Queries the type of the parameter that must be given when activating `action`.

When activating the action using `actionActivate`, the `GVariant` given to that function must be of the type returned by this function.

In the case that this function returns `Nothing`, you must not give any `GVariant`, but `Nothing` instead.

Since: 2.28

## getState

actionGetState Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Action`
-> m GVariant | Returns: the current state of the action

Queries the current state of `action`.

If the action is not stateful then `Nothing` will be returned. If the action is stateful then the type of the return value is the type given by `actionGetStateType`.

The return value (if non-`Nothing`) should be freed with `variantUnref` when it is no longer required.

Since: 2.28

## getStateHint

actionGetStateHint Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Action`
-> m (Maybe GVariant) | Returns: the state range hint

Requests a hint about the valid range of values for the state of `action`.

If `Nothing` is returned it either means that the action is not stateful or that there is no hint about the valid range of values for the state of the action.

If a `GVariant` array is returned then each item in the array is a possible value for the state. If a `GVariant` pair (ie: two-tuple) is returned then the tuple specifies the inclusive lower and upper bound of valid values for the state.

In any case, the information is merely a hint. It may be possible to have a state value outside of the hinted range and setting a value within the range may fail.

The return value (if non-`Nothing`) should be freed with `variantUnref` when it is no longer required.

Since: 2.28

## getStateType

actionGetStateType Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Action`
-> m (Maybe VariantType) | Returns: the state type, if the action is stateful

Queries the type of the state of `action`.

If the action is stateful (e.g. created with `simpleActionNewStateful`) then this function returns the `VariantType` of the state. This is the type of the initial value given as the state. All calls to `actionChangeState` must give a `GVariant` of this type and `actionGetState` will return a `GVariant` of the same type.

If the action is not stateful (e.g. created with `simpleActionNew`) then this function will return `Nothing`. In that case, `actionGetState` will return `Nothing` and you must not call `actionChangeState`.

Since: 2.28

## nameIsValid

actionNameIsValid Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `actionName`: a potential action name
-> m Bool | Returns: `True` if `actionName` is valid

Checks if `actionName` is valid.

`actionName` is valid if it consists only of alphanumeric characters, plus '-' and '.'. The empty string is not a valid action name.

It is an error to call this function with a non-utf8 `actionName`. `actionName` must not be `Nothing`.

Since: 2.38

## parseDetailedName

actionParseDetailedName Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `detailedName`: a detailed action name
-> m (Text, GVariant) | (Can throw `GError`)

Parses a detailed action name into its separate name and target components.

Detailed action names can have three formats.

The first format is used to represent an action name with no target value and consists of just an action name containing no whitespace nor the characters ':', '(' or ')'. For example: "app.action".

The second format is used to represent an action with a target value that is a non-empty string consisting only of alphanumerics, plus '-' and '.'. In that case, the action name and target value are separated by a double colon ("::"). For example: "app.action[target](#g:signal:target)".

The third format is used to represent an action with any type of target value, including strings. The target value follows the action name, surrounded in parens. For example: "app.action(42)". The target value is parsed using `variantParse`. If a tuple-typed value is desired, it must be specified in the same way, resulting in two sets of parens, for example: "app.action((1,2,3))". A string target can be specified this way as well: "app.action('target')". For strings, this third format must be used if * target value is empty or contains characters other than alphanumerics, '-' and '.'.

Since: 2.38

## printDetailedName

actionPrintDetailedName Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `actionName`: a valid action name
-> Maybe GVariant | `targetValue`: a `GVariant` target value, or `Nothing`
-> m Text | Returns: a detailed format string

Formats a detailed action name from `actionName` and `targetValue`.

It is an error to call this function with an invalid action name.

This function is the opposite of `actionParseDetailedName`. It will produce a string that can be parsed back to the `actionName` and `targetValue` by that function.

See that function for the types of strings that will be printed by this function.

Since: 2.38

# Properties

## enabled

If `action` is currently enabled.

If the action is disabled then calls to `actionActivate` and `actionChangeState` have no effect.

Since: 2.28

getActionEnabled :: (MonadIO m, IsAction o) => o -> m Bool Source #

Get the value of the “`enabled`” property. When overloading is enabled, this is equivalent to

    get action #enabled

## name

The name of the action. This is mostly meaningful for identifying the action once it has been added to a `ActionGroup`. It is immutable.

Since: 2.28

getActionName :: (MonadIO m, IsAction o) => o -> m Text Source #

Get the value of the “`name`” property. When overloading is enabled, this is equivalent to

    get action #name

## parameterType

The type of the parameter that must be given when activating the action. This is immutable, and may be `Nothing` if no parameter is needed when activating the action.

Since: 2.28

getActionParameterType :: (MonadIO m, IsAction o) => o -> m (Maybe VariantType) Source #

Get the value of the “`parameter-type`” property. When overloading is enabled, this is equivalent to

    get action #parameterType

## state

The state of the action, or `Nothing` if the action is stateless.

Since: 2.28

getActionState :: (MonadIO m, IsAction o) => o -> m (Maybe GVariant) Source #

Get the value of the “`state`” property. When overloading is enabled, this is equivalent to

    get action #state

## stateType

The `VariantType` of the state that the action has, or `Nothing` if the action is stateless. This is immutable.

Since: 2.28

getActionStateType :: (MonadIO m, IsAction o) => o -> m (Maybe VariantType) Source #

Get the value of the “`state-type`” property. When overloading is enabled, this is equivalent to

    get action #stateType